<?php
	/*
		Plugin Name: oxyXML generator
		Plugin URI: http://www.oxeron.com/category/open-source/wordpress-plugin-oxyxml
		Description: Generates xml file for displaying your posts on other websites.
		Version: 0.1
		Author: Olivier Pierre
		Author URI: http://www.oxeron.com/
	*/
	$oxyXML_version = "0.1";

	add_option('oxyXML_active', true);
	add_option('oxyXML_categories', "");
	add_option('oxyXML_path', "./");	
	add_option('oxyXML_delay', "30");	
	
	$oxyXML_active = get_option('oxyXML_active');
	$oxyXML_categories = get_option('oxyXML_categories');
	$oxyXML_path = get_option('oxyXML_path');
	$oxyXML_delay = get_option('oxyXML_delay');

	add_action('admin_menu', 'oxyXML_add_pages');
	if ($oxyXML_active) {
		add_action('edit_post', 'oxyXML_generate_xml');
		add_action('delete_post', 'oxyXML_generate_xml');
		add_action('private_to_published', 'oxyXML_generate_xml');
		add_action('publish_page', 'oxyXML_generate_xml');
		add_action('publish_phone', 'oxyXML_generate_xml');
		add_action('publish_post', 'oxyXML_generate_xml');
		add_action('save_post', 'oxyXML_generate_xml');
		add_action('xmlrpc_publish_post', 'oxyXML_generate_xml');
	}

	function oxyXML_add_pages() {
		add_options_page("oxyXML generator", "oxyXML", 8, basename(__FILE__), "oxyXML_admin_page");
	}

	function oxyXML_permissions() {
		$oxyXML_active = get_option('oxyXML_active');		
		$oxyXML_path = ABSPATH . get_option('oxyXML_path');
		$oxyXML_file_path = $oxyXML_path . "posts.xml";		

		if ($oxyXML_active && is_file($oxyXML_file_path) && is_writable($oxyXML_file_path)) $oxyXML_permission = 0;
		elseif ($oxyXML_active && !is_file($oxyXML_file_path) && is_writable($oxyXML_path)) {
			$fp = fopen($oxyXML_file_path, 'w');
			fwrite($fp, "<?xml version=\"1.0\" encoding=\"UTF-8\"?><urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" />");
			fclose($fp);
			if (is_file($oxyXML_file_path) && is_writable($oxyXML_file_path)) $oxyXML_permission = 0;
			else $oxyXML_permission = 1;
		}
		elseif ($oxyXML_active) $oxyXML_permission = 1;
		else $oxyXML_permission = 0;		
		return $oxyXML_permission;
	}


	function oxyXML_generate_xml() {
		global $oxyXML_version, $table_prefix,$msg;		
		$t = $table_prefix;
		$oxyXML_active = get_option('oxyXML_active');		
		$oxyXML_categories = get_option('oxyXML_categories');
		$oxyXML_path = get_option('oxyXML_path');
		$oxyXML_delay = get_option('oxyXML_delay');
		$oxyXML_permission = oxyXML_permissions();
		if ($oxyXML_permission > 2 || (!$oxyXML_active)) return;		
		mysql_connect(DB_HOST, DB_USER, DB_PASSWORD);
		mysql_query("SET NAMES '".DB_CHARSET."'");
		mysql_select_db(DB_NAME);
		$home = get_option('home') . "/";
		
		$out = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
		$out .= "\n<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">
	<!-- Generated by oxyXML ".$oxyXML_version." plugin -->
	<!-- http://www.oxeron.com/opensource/plugin-wordpress -->
	<!-- Created ".date("F d, Y, H:i")."-->";
				
		$result = mysql_query("
			SELECT 
				`".$t."posts`.`ID`, `".$t."posts`.`post_title`, `".$t."posts`.`post_date`, `".$t."posts`.`post_modified_gmt`, `".$t."posts`.`post_name`, `".$t."posts`.`post_type`,
				MAX(`".$t."comments`.`comment_date_gmt`) AS `comment_date_gmt`, MAX(`".$t."comments`.`comment_date`) AS `comment_date` ,
				`".$t."term_taxonomy`.`term_id`, `".$t."terms`.`name`
			FROM `".$t."posts`
			LEFT JOIN `".$t."comments` ON `".$t."comments`.`comment_post_ID` = `".$t."posts`.`ID`
			LEFT JOIN `".$t."term_relationships` ON `".$t."term_relationships`.`object_id` = `".$t."posts`.`ID`
			LEFT JOIN `".$t."terms` ON `".$t."terms`.`term_id` = `".$t."term_relationships`.`term_taxonomy_id`
			LEFT JOIN `".$t."term_taxonomy` ON `".$t."term_taxonomy`.`term_taxonomy_id` = `".$t."term_relationships`.`term_taxonomy_id` 
			WHERE
				`".$t."posts`.`post_status`='publish'
				AND (
					`".$t."posts`.`post_type`='page'
					OR `".$t."posts`.`post_type`='post'
				)
				AND (
					`".$t."comments`.`comment_approved`='1'
					OR `".$t."comments`.`comment_approved` IS NULL
				)
				AND `".$t."posts`.`post_title` != 'WPG2'
				AND `".$t."term_taxonomy`.term_id IN (".$oxyXML_categories.")
			GROUP BY `".$t."posts`.`ID`
			ORDER BY `".$t."posts`.`post_modified_gmt` DESC
		");			
		$now = time();
		$xDays = $oxyXML_delay*24*60*60;
		while ($data = mysql_fetch_assoc($result)) {		
			if ($oxyXML_active && $oxyXML_permission != 1) {
				$postDate = strtotime($data['post_date']);
				if ($now - $postDate < $xDays) {
					$out .= "<post>
									<url>".get_permalink($data['ID'])."</url>
									<category>".$data['name']."</category>
									<category_id>".$data['term_id']."</category_id>
									<posted>".$data['post_date']."</posted>
									<title>".$data['post_title']."</title>
							</post>";
				}				
			}
		}
		$out .= "\n</urlset>";		
		if ($oxyXML_active && $oxyXML_permission != 1) {
			if (is_writable(ABSPATH . $oxyXML_path . "posts.xml")) {
				$fp = fopen(ABSPATH . $oxyXML_path . "posts.xml", 'w');
				if (fwrite($fp, $out) === FALSE) {
			        $msg="Unable to write data to file ".ABSPATH . $oxyXML_path . "posts.xml";
			        exit;
			    }
				fclose($fp);
			} else $msg="Error: File ".ABSPATH . $oxyXML_path . "posts.xml is not writeable";
		}
		
	}

	function oxyXML_admin_page() {
		$msg = "";
		if ('oxyXML_submit' == $_POST['oxyXML_submit']) {
			update_option('oxyXML_active', $_POST['oxyXML_active']);
			update_option('oxyXML_categories', $_POST['oxyXML_categories']);
			update_option('oxyXML_delay', $_POST['oxyXML_delay']);			
			$newPath = trim($_POST['oxyXML_path']);
			if ($newPath == "" || $newPath == "/") $newPath = "./";
			elseif ($newPath[strlen($newPath)-1] != "/") $newPath .= "/";
			update_option('oxyXML_path', $newPath);					
			oxyXML_generate_xml();
		}
		$oxyXML_active = get_option('oxyXML_active');
		$oxyXML_categories = get_option('oxyXML_categories');
		$oxyXML_path = get_option('oxyXML_path');
		$oxyXML_delay = get_option('oxyXML_delay');
		$oxyXML_permission = oxyXML_permissions();
		if ($oxyXML_permission == 1) $msg = "Error: there is a problem with <em>posts.xml</em>. It doesn't exist or is not writable.";
	?>
	<div class="wrap">
<?php	if ($msg) {	?>
	<div id="message" class="error"><p><strong><?php echo $msg; ?></strong></p></div>
<?php	}	?>
		<form name="form1" method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>&amp;updated=true">
			<input type="hidden" name="oxyXML_submit" value="oxyXML_submit" />
			<table class="form-table">
				<tr valign="top">
					<th scope="row">XML settings</th>
					<td>
						<label for="oxyXML_active">
							<input name="oxyXML_active" type="checkbox" id="oxyXML_active" value="1" <?php echo $oxyXML_active?'checked="checked"':''; ?> />
							Create XML file.
						</label><br />
						
						<br />
						<label for="oxyXML_categories">
							Comma separated list of categories Id to show. <input name="oxyXML_categories" type="text" id="oxyXML_categories" value="<?php echo $oxyXML_categories?>" />
						</label><br />
						<br />
						<label for="oxyXML_delay">
							How many days of posts to show. <input name="oxyXML_delay" type="text" id="oxyXML_delay" value="<?php echo $oxyXML_delay?>" />
						</label>						
					</td>
				</tr>
				<tr valign="top">
					<th scope="row">Advanced settings</th>
					<td>
						XML path (relatively to blog's home): <input name="oxyXML_path" type="text" id="oxyXML_path" value="<?php echo $oxyXML_path?>" />
						<br />
					</td>
				</tr>
			</table>
			<p class="submit">
				<input type="submit" value="Save &amp; Rebuild" />
			</p>
		</form>
	</div>
<?php
	}
?>